-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['tilt'] = 0
  electrics.values['tilt_input'] = 0
  electrics.values['extend'] = 0
  electrics.values['extend_input'] = 0

  electrics.values['bogie_steer'] = 0
  electrics.values['bogieh'] = 0
  electrics.values['bogieh_input'] = 0
   
end

local function updateGFX(dt) -- ms
  electrics.values['tilt'] = math.min(1, math.max(-0.0, (electrics.values['tilt'] + electrics.values['tilt_input'] * dt * 0.25)))
  electrics.values['extend'] = math.min(1, math.max(-0.0, (electrics.values['extend'] + electrics.values['extend_input'] * dt * 0.25)))
	
	electrics.values['bogie_steer'] = electrics.values['signal_left_input'] - electrics.values['signal_right_input']
	electrics.values['bogieh'] = math.min(1, math.max(0, (electrics.values['bogieh'] + electrics.values['bogieh_input'] * dt * 0.25)))	
end

local function tiltBed(value)
  electrics.values.tilt_input = value
end

local function extendBed(value)
  electrics.values.extend_input = value
  electrics.values.bogieh_input = value
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX
M.tiltBed = tiltBed
M.extendBed = extendBed

return M
